【算法】位运算算法——消失的两个数字(困难)

题解:消失的两个数字(位运算算法)

目录

1.题目

题目链接:LINK

2.题解

本题要求时间复杂度O(N),空间复杂度O(1),分别否了我们 排序遍历 和 哈希数组 的想法。想要在规定时间/空间复杂度内完成本题,需要借用 位运算算法。

具体该如何操作呢?

①首先,我们将 原数组 与 1,n+2 的数字全部 异或起来 ,这时候会得出 ret = a ^ b

②根据ret,我们可以知道 a 与 b 的不同的一位二进制 ,我们根据这位不同的二进制来区分a 和 b

③让 原数组 和 1,n+2 数字根据不同的这一二进制位 站队 ,再把两队全部异或起来消去相同的一项得出a 和 b,因为a 和 b只在1,n+2中出现过一次因而不会被异或掉。

可能单纯叙述有点抽象,我直接用一个例子来说明我上面说的步骤:







3.示例代码如下

cpp 复制代码
class Solution {
public:
    vector<int> missingTwo(vector<int>& nums) 
    {
        int ret = 0;
        for(auto& num : nums) ret ^= num;
        for(int i = 1; i <= nums.size()+2; i++) ret ^= i; 
        
        //ret = a ^ b
        int count = 0;

        while(1)
        {
            if(((ret >> count) & 1) == 1) break;
            else count++;
        }
        
        int a = 0;
        int b = 0;
        for(auto& num: nums) 
        {
            if(((num >> count) & 1) == 1) a ^= num;
            else b^=num;
        }
        for(int i = 0; i <= nums.size()+2; i++)
        {
            if(((i >> count) & 1) == 1) a ^= i;
            else b^=i;
        }
       
        return {a,b};
    }
};

4.总结

这道题整体的思路是这样的,我们先找出ret = a ^ b来,主要是为了确定这俩数字哪个二进制位不一样,方便将其归纳到不同的组中去,两个消失的数字归纳到不同的组之后我们可以用异或的两两相消原理,把重复的数字全部干掉,一组只剩下a,一组只剩下b,返回即可。

拓展:位运算常用操作:LINK


EOF

相关推荐
生态学者3 小时前
Global Change Biology | 森林越“步调一致”,反而越怕干旱?树木生长与叶片活动的同步之谜
大数据·人工智能·算法·r语言·微信公众平台
所以遗憾是什么呢?3 小时前
【题解】Educational Codeforces Round 195 (Rated for Div. 2) ABCDE
c++·动态规划·acm·icpc·ccpc·xcpc·codeforecs
lsswear3 小时前
Agent 框架新手入门与实战部署指南
大数据·人工智能·算法
Lhan.zzZ4 小时前
Qt WebEngineView 在 Linux 上无法加载网页:从“看不见 HTML“到“禁用沙箱“
linux·c++·qt
Data analyse4565 小时前
rnweb 回放数据量太大怎么办?分片存储与断点续传的实现思路
前端·网络·算法·数据分析
sysu_chenxy6 小时前
二重循环输出二维图形
c++
Navigator_Z6 小时前
LeetCode //C - 1293. Shortest Path in a Grid with Obstacles Elimination
c语言·算法·leetcode
Nil2087 小时前
leetcode 64最小路径和
算法·leetcode·职场和发展
光影少年7 小时前
AI Agent、自动化与未来工作
人工智能·算法·架构
牧羊人.3337 小时前
计算机视觉基础 第16章|EigenFace,FisherFace,LBPH传统人脸识别算法
人工智能·算法·计算机视觉